//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//| original code by master mladenfx                                 |
//| modified by chriz aka Indiana Pips @ FF                          |
//+------------------------------------------------------------------+
#property copyright "free"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 DarkGreen  
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 Blue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

extern string    MAMethod = "MODE_SMA = 0 Simple moving average, MODE_EMA = 1 Exponential moving average, MODE_SMMA = 2 Smoothed moving average, MODE_LWMA = 3 Linear weighted moving average";
extern string    MAPrice = "PRICE_CLOSE = 0 Close price, PRICE_OPEN = 1 Open price, PRICE_HIGH = 2 High price, PRICE_LOW = 3 Low price " ;  
extern string    MAPrice_ = "PRICE_MEDIAN = 4 Median price (high+low)/2 , PRICE_TYPICAL = 5 Typical price (high+low+close)/3 , PRICE_WEIGHTED = 6 Weighted close price (high+low+close+close)/4 " ; 

extern int       FastMAPeriod=20;
extern int       FastMAMethod=MODE_EMA;
extern int       FastMAPrice =PRICE_CLOSE;
extern int       SlowMAPeriod=55;
extern int       SlowMAMethod=MODE_EMA;
extern int       SlowMAPrice =PRICE_CLOSE;
extern bool   AlertOn = true,
              EmailOn = false,
              AlertOnClosedCandle = false;
extern bool    ShowArrows = true;
extern int     ArrowWidth = 2;
extern color   ArrowsUpColor = Green,
               ArrowsDnColor = Red;
//extern int    Corner = 1;               


double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
int Trend=0,SignalCandle=0;
datetime LastAlert=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1); SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,buffer2); SetIndexStyle(3,DRAW_LINE);
   if (AlertOnClosedCandle) SignalCandle=1;
   return(0);
}
int deinit() {
   Comment("");
   if (ShowArrows) {
      for (int i=ObjectsTotal()-1;i>=0;i--) {
         if (StringFind(ObjectName(i),"MARibbon")>-1) ObjectDelete(ObjectName(i));
         }
      }
   ObjectDelete("Trade");
   return;
} 


int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;


   for(i=limit; i>=0; i--)
   {
      buffer1[i] = iMA(NULL,0,FastMAPeriod,0,FastMAMethod,FastMAPrice,i);
      buffer2[i] = iMA(NULL,0,SlowMAPeriod,0,SlowMAMethod,SlowMAPrice,i);
      //buffer3[i] = buffer1[i];
      //buffer4[i] = buffer2[i];
      buffer3[i] = EMPTY_VALUE ;
      buffer4[i] = EMPTY_VALUE ;
      if (buffer1[i+SignalCandle]>buffer2[i+SignalCandle] && buffer1[i+1+SignalCandle]<=buffer2[i+1+SignalCandle] && Trend<1) {
         Trend=1;
	      if (ShowArrows) DrawArrow(i+SignalCandle,buffer2[i+SignalCandle],ArrowsUpColor,233,false);
      }
      else if (buffer1[i+SignalCandle]<buffer2[i+SignalCandle] && buffer1[i+1+SignalCandle]>=buffer2[i+1+SignalCandle] && Trend>-1) {
      	Trend=-1;
      	if (ShowArrows) DrawArrow(i+SignalCandle,buffer2[i+SignalCandle],ArrowsDnColor,234,true);         
      }
      
      if ( buffer1[i+SignalCandle]>=buffer2[i+SignalCandle])
      {
         buffer3[i] = buffer1[i];
      }
      else if ( buffer1[i+SignalCandle]<buffer2[i+SignalCandle] ) 
      {
         buffer4[i] = buffer2[i] ;               	        
      }

   }
   if (buffer1[SignalCandle]>buffer2[SignalCandle] && buffer1[SignalCandle+1]<=buffer2[SignalCandle+1] && LastAlert!=Time[0]) {
      LastAlert=Time[0];
      if (AlertOn) Alert("MA Ribbon Buy Alert! - "+Symbol()+"["+Period()+"m]");
      if (EmailOn) SendMail("MA Ribbon Buy Alert!","Buy alert on "+Symbol()+"["+Period()+"m]");
      }
   else if (buffer1[SignalCandle]<buffer2[SignalCandle] && buffer1[SignalCandle+1]>=buffer2[SignalCandle+1] && LastAlert!=Time[0]) {
      LastAlert=Time[0];
      if (AlertOn) Alert("MA Ribbon Sell Alert! - "+Symbol()+"["+Period()+"m]");
      if (EmailOn) SendMail("MA Ribbon Sell Alert!","Sell alert on "+Symbol()+"["+Period()+"m]");
      }
   /*
   string OPstr;
   color OPclr;
   if (Trend>0) {
      OPstr = "BUY";
      OPclr = Green;
      }
   else if (Trend<0) {
      OPstr = "SELL";
      OPclr = Red;
      }
   else {
      OPstr = "NO Trade";
      OPclr = Red;
      }
   ObjectCreate("Trade", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Trade", OPstr, 15, "Arial Bold", OPclr);
   ObjectSet("Trade", OBJPROP_CORNER, Corner);
   ObjectSet("Trade", OBJPROP_XDISTANCE, 20);
   ObjectSet("Trade", OBJPROP_YDISTANCE, 20);
   */
   return(0);
}
void DrawArrow(int i, double ma, color theColor,int theCode,bool up) {
   string name = "MARibbon:"+Time[i];
   double gap  = 3.0*iATR(NULL,0,10,i)/4.0;   
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_WIDTH,ArrowWidth);
      if (up)
            ObjectSet(name,OBJPROP_PRICE1,ma+gap);
      else  ObjectSet(name,OBJPROP_PRICE1,ma-gap);
   return;
}

